import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 13.11.2013
  * @author 
  */

public class Songwriter extends JApplet {
  // Anfang Attribute
  private JLabel jLText = new JLabel();
  private JLabel jLAusgabe = new JLabel();
  private JButton jBEingabe = new JButton();
  // Ende Attribute
  
  public void init() {
    Container cp = getContentPane();
    cp.setLayout(null);
    cp.setBounds(0, 0, 300, 800);
    // Anfang Komponenten
    
    jLText.setBounds(16, 32, 123, 33);
    jLText.setText("  Erzuege den Song");
    cp.add(jLText);
    jLAusgabe.setBounds(8, 112, 227, 500);
    jLAusgabe.setText("");
    cp.add(jLAusgabe);
    jBEingabe.setBounds(152, 32, 89, 33);
    jBEingabe.setText("Text");
    jBEingabe.setMargin(new Insets(2, 2, 2, 2));
    jBEingabe.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jBEingabe_ActionPerformed(evt);
      }
    });
    cp.add(jBEingabe);
    // Ende Komponenten
    
  } // end of init
  //Funktion fr Zufallszahl 
  public int Zuzahl(int zz) {
    return (int) (Math.random() * zz);    //Zufallszahl mit Maximum zurckgeben
  }
  
  //Funktion zur Silbenbestimmung
  public String Silben(String Kon){
    char[] Vokale = {'A', 'E', 'I', 'O', 'U'};                   //Vokale Einspeisen
    char[] Konsonanten = "BCDFGHJKLMNPQRSTVWXYZ".toCharArray();  //Konsonaten Einspeisen
    String Silbe = ""; //Silbe bestimmen LeerMenge
    
    if (Kon == "") {
      Silbe = "" + Konsonanten[Zuzahl(20)] + Vokale[Zuzahl(4)]; // Konsonaten zufllig whlen und in String speichern, ebenso Vokal
    }
    else {
      Silbe = "" + Kon + Vokale[Zuzahl(4)];        // Konsonaten von vorher whlen und in String speichern, Vokal zufllig
    }
    return Silbe;
  }
  
  
  //Funktion zur Bestimmung der Zeilen
  public String[] Zeilen(int Silbenzahl, String[] Silben, int Zeilen) {
    String[] End_zeile = new String[Zeilen];        //String fr den Return
    int Mitte = ((int) (Silbenzahl / 2));          //Mitte der Silbenkolonne bestimmen, um p di anhngen
    // System.out.println(Mitte);
    for (int i = 0;i < Zeilen ; i++) {             //Fr Jede Zeile
      for (int j = 0;j < Silbenzahl ;j++ ) {      //Silbe j-mal wiederholen
        if (j == 0) {                           //Wenn Startwert ist, ohne Leerzeichen
          End_zeile[i] = Silben[i];
        } else if (j == (Silbenzahl - 1)) {     //Bei Ende Ausrufezeichen
          End_zeile[i] += " " + Silben[i] + " !";
        } else if (j == Mitte) {                 //Bei Mitte p di einfgen 
          End_zeile[i] += " " + Silben[i] + "P DI ";
        } else {
          End_zeile[i] += " " + Silben[i];       //Ansonsten normal die Silbe mit Leerzeichen vorher einfgen
        } 
      }
    }
    return End_zeile;                              //Voraussichtliches Ende der Zeilen zurckgeben
  }
  
  
  //Funktion fr einen Spruch
  public String Spruch(String Zeilen) {
    int Spruch = Zuzahl(2);                                    //Integer-Wert entscheidet nachher darber, ob ein Spruch rein soll, oder nicht
    String[] Sprueche = {"YEAH!", "YO MAN!", "FAKE THAT!", "SWAG!", "OH YEAH!", "RAP DI RAP!"};   //Coole Enden
    if (Spruch == 1) {
      Zeilen += Sprueche[Zuzahl(5)];
    }
    return Zeilen;
  } 
  
  
  public String Strophe() {              //Songmuster definieren -> Strophe
    //Zahlen definieren
    int  Zeilen = Zuzahl(3) + 2;                  //Zeilenzahl    Schranke 2 (min. 2)
    int  Silbenzahl = (Zuzahl(2) + 2) * 2 - 1;      //Strophenzahl  Schranke ist 2 (min. 2), muss ungerade sein: Irgendetwas *2 -1 ist immer ungerade (vorausgesetzt Integer)
    String[] Zeilensilbe = new String[Zeilen];        //Zeilensilbe in Abhngigkeit von der Zeilenzahl
    int Silbe_neu = Zuzahl(3) + 2;                          //Punkt fr neue Silbe  (min. nach 2)
    String[] Zeilen_Strophe = new String[Zeilen];
    String Ausgabe = "";                                            //Ausgabe-String
    
    
    /************** Silben fr Zeilen bestimmen *********/
    for (int i = 0;i < Zeilen ;i++ ) {     //Solange wie es Zeilen gibt 
      if (i == 0) {
        Zeilensilbe[i] = Silben("");
      } else if (i == Silbe_neu) {         //Neue Silbe ?
        Zeilensilbe[i] = Silben("");
      } else {
        Zeilensilbe[i] = "" + Silben("" + Zeilensilbe[i-1].charAt(0));    //Alter Konsonant, neuer Vokal
      }
    }
    /********************************************************/
    //Zeilen eintragen in String
    Zeilen_Strophe = Zeilen(Silbenzahl, Zeilensilbe, Zeilen);   //Zeilen fertig machen
    for (int i = 0;i < Zeilen_Strophe.length ; i++) {                     //Strophe in String umwandeln
      Ausgabe += Zeilen_Strophe[i] + "<br>";
    }
    Ausgabe = Spruch(Ausgabe) + "<br>";                                 //Spruch ?
    
    return Ausgabe;                                               //fertige Strophe zurckgeben
  }
  
  /********** Vollstndiges Lied konzipieren ******/
  public String Lied() {
         String Ausgabe = "";         //Ausgabe-String
         int Strophe = Zuzahl(3) + 2;   //Maximal Anzahl der Strophen 5
         
         //Strophen schreiben
         for (int i = 0;i < Strophe ;i++ ) {
           Ausgabe += Strophe() + "<br><br>";
         }
         
         return Ausgabe;          //Ausgabe zurckgeben
  }
  
  // Anfang Methoden
  public void jBEingabe_ActionPerformed(ActionEvent evt) {
    String Ausgabe = Lied();                                 //Ausgabestring
    
    jLAusgabe.setText("<html><body>" + Ausgabe + "</body></html>");     //HTML fr Abstze
  } // end of jBEingabe_ActionPerformed
  
  // Ende Methoden
  
} // end of class Songwriter
